## doctest 2.4.5+repack0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

if(POLICY CMP0077)
    cmake_policy(SET CMP0077 NEW)
endif()

################################################################################
## DOCTEST
################################################################################

file(READ ${CMAKE_CURRENT_SOURCE_DIR}/scripts/version.txt ver)
project(doctest VERSION ${ver} LANGUAGES CXX)

# Determine if doctest is built as a subproject (using add_subdirectory) or if it is the main project.
set(MAIN_PROJECT OFF)
if(CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
    set(MAIN_PROJECT ON)
endif()

option(DOCTEST_WITH_TESTS               "Build tests/examples" ${MAIN_PROJECT})
option(DOCTEST_WITH_MAIN_IN_STATIC_LIB  "Build a static lib (cmake target) with a default main entry point" ON)
option(DOCTEST_NO_INSTALL  "Skip the installation process" OFF)
option(DOCTEST_USE_STD_HEADERS  "Use std headers" OFF)

add_library(${PROJECT_NAME} INTERFACE)
add_library(${PROJECT_NAME}::${PROJECT_NAME} ALIAS ${PROJECT_NAME})

if(NOT CMAKE_VERSION VERSION_LESS 3.8)
    target_compile_features(${PROJECT_NAME} INTERFACE cxx_std_11)
endif()

set(doctest_parts_folder "${CMAKE_CURRENT_SOURCE_DIR}/doctest/parts")
set(doctest_folder "${CMAKE_CURRENT_SOURCE_DIR}/") # in order to have the mpi extension files, not included into the doctest.h single header

if(MAIN_PROJECT)
    # use a special hidden version of the header which directly includes the 2 parts - proper reporting of file/line locations during dev
    target_include_directories(${PROJECT_NAME} INTERFACE
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/scripts/development_only/>
        $<BUILD_INTERFACE:${doctest_parts_folder}>
        $<BUILD_INTERFACE:${doctest_folder}>)

    # add a custom target that assembles the single header when any of the parts are touched
    add_custom_command(
        OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/doctest/doctest.h
        DEPENDS
            ${doctest_parts_folder}/doctest_fwd.h
            ${doctest_parts_folder}/doctest.cpp
        COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_SOURCE_DIR}/scripts/cmake/assemble_single_header.cmake
        COMMENT "assembling the single header")

    add_custom_target(assemble_single_header ALL DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/doctest/doctest.h)
else()
    target_include_directories(${PROJECT_NAME} INTERFACE $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/>)
endif()

# hack to support building on XCode 6 and 7 - propagate the definition to everything
if(DEFINED DOCTEST_THREAD_LOCAL)
    target_compile_definitions(${PROJECT_NAME} INTERFACE
        DOCTEST_THREAD_LOCAL=${DOCTEST_THREAD_LOCAL})
endif()

if(DOCTEST_USE_STD_HEADERS)
    target_compile_definitions(${PROJECT_NAME} INTERFACE DOCTEST_CONFIG_USE_STD_HEADERS)
endif()

################################################################################
## TESTS/EXAMPLES/HELPERS
################################################################################

if(${DOCTEST_WITH_MAIN_IN_STATIC_LIB})
    add_library(${PROJECT_NAME}_with_main STATIC EXCLUDE_FROM_ALL ${doctest_parts_folder}/doctest.cpp)
    target_compile_definitions(${PROJECT_NAME}_with_main PRIVATE
        DOCTEST_CONFIG_IMPLEMENT_WITH_MAIN)
    set_target_properties(${PROJECT_NAME}_with_main PROPERTIES CXX_STANDARD 11 CXX_STANDARD_REQUIRED ON)
    target_link_libraries(${PROJECT_NAME}_with_main PUBLIC ${PROJECT_NAME})
endif()

if(MAIN_PROJECT AND DOCTEST_WITH_TESTS)
    include(scripts/cmake/common.cmake)

    add_subdirectory(examples/all_features)

    # for code coverage we want exactly one binary to be produced and exercised
    if(NOT DEFINED ENV{CODE_COVERAGE})
        add_subdirectory(examples/exe_with_static_libs)
        add_subdirectory(examples/executable_dll_and_plugin)
        add_subdirectory(examples/combining_the_same_tests_built_differently_in_multiple_shared_objects)
        add_subdirectory(scripts/playground)
        add_subdirectory(examples/mpi)
    endif()
endif()

################################################################################
## PACKAGE SUPPORT
################################################################################

set(generated_dir "${CMAKE_CURRENT_BINARY_DIR}/generated")

if(CMAKE_SYSTEM_NAME STREQUAL Linux)
    include(GNUInstallDirs)
    set(include_install_dir ${CMAKE_INSTALL_INCLUDEDIR})
    set(config_install_dir "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}")
else()
    set(include_install_dir "include")
    set(config_install_dir "lib/cmake/${PROJECT_NAME}")
endif()


set(version_config "${generated_dir}/${PROJECT_NAME}ConfigVersion.cmake")
set(project_config "${generated_dir}/${PROJECT_NAME}Config.cmake")
set(targets_export_name "${PROJECT_NAME}Targets")
set(namespace "${PROJECT_NAME}::")

include(CMakePackageConfigHelpers)

# CMake automatically adds an architecture compatibility check to make sure
# 32 and 64 bit code is not accidentally mixed. For a header-only library this
# is not required. The check can be disabled by temporarily unsetting
# CMAKE_SIZEOF_VOID_P. In CMake 3.14 and later this can be achieved more cleanly
# with write_basic_package_version_file(ARCH_INDEPENDENT).
# TODO: Use this once a newer CMake can be required.
set(DOCTEST_SIZEOF_VOID_P ${CMAKE_SIZEOF_VOID_P})
unset(CMAKE_SIZEOF_VOID_P)
write_basic_package_version_file(
    "${version_config}" VERSION ${PROJECT_VERSION} COMPATIBILITY SameMajorVersion
)
set(CMAKE_SIZEOF_VOID_P ${DOCTEST_SIZEOF_VOID_P})

configure_file("scripts/cmake/Config.cmake.in" "${project_config}" @ONLY)

if(NOT ${DOCTEST_NO_INSTALL})
    install(
        TARGETS ${PROJECT_NAME}
        EXPORT "${targets_export_name}"
        INCLUDES DESTINATION "${include_install_dir}"
    )

    install(
        FILES "doctest/doctest.h"
        DESTINATION "${include_install_dir}/doctest"
    )

    install(
        FILES "${project_config}" "${version_config}"
        DESTINATION "${config_install_dir}"
    )

    install(
        FILES "scripts/cmake/doctest.cmake" "scripts/cmake/doctestAddTests.cmake"
        DESTINATION "${config_install_dir}"
    )

    install(
        EXPORT "${targets_export_name}"
        NAMESPACE "${namespace}"
        DESTINATION "${config_install_dir}"
    )
endif()

=== examples/all_features/CMakeLists.txt ===
################################################################################
## BUILD ALL EXAMPLE SOURCES INTO A SINGLE BINARY AND EXECUTE TESTS ON EACH FILE
################################################################################

set(files_with_output
    main.cpp
    doctest_proxy.h
    header.h
    alternative_macros.cpp
    assertion_macros.cpp
    stringification.cpp
    reporters_and_listeners.cpp
    subcases.cpp
    logging.cpp
    templated_test_cases.cpp
    test_cases_and_suites.cpp
    asserts_used_outside_of_tests.cpp
    enums.cpp
)

set(files_all
    ${files_with_output}
    concurrency.cpp
    ../../scripts/coverage_maxout.cpp
)

# add the executable
add_executable(all_features ${files_all})
target_link_libraries(all_features doctest ${CMAKE_THREAD_LIBS_INIT})

# easy way to fix test coverage - disable colors and crash handling
target_compile_definitions(all_features PRIVATE
    DOCTEST_CONFIG_COLORS_NONE
    DOCTEST_CONFIG_NO_POSIX_SIGNALS
    DOCTEST_CONFIG_NO_WINDOWS_SEH)

# omit the version and the num test cases skipped from the summary - this way the output will change less often
set(common_args COMMAND $<TARGET_FILE:all_features> --no-skipped-summary --no-version)

# add per-file tests
foreach(f ${files_with_output})
    doctest_add_test(NAME ${f} ${common_args} -sf=*${f})
endforeach()

# add this separately since it shouldn't have output compared to reference output - due to concurrency
# not adding it for MinGW since it crashes when using mingw-w64-x86_64-8.1.0-release-posix-seh-rt_v6-rev0
# (also disabled for old XCode builds on travis where there is no thread_local support and this is defined in the build matrix)
if(NOT MINGW AND NOT DEFINED DOCTEST_THREAD_LOCAL)
    doctest_add_test(NO_OUTPUT NAME concurrency.cpp ${common_args} -sf=*concurrency.cpp -d) # duration: there is no output anyway
endif()

# add this separately since the file has a non-straightforward path
doctest_add_test(NAME coverage_maxout.cpp ${common_args} -sf=*coverage_maxout.cpp)

# queries
doctest_add_test(NAME version           COMMAND $<TARGET_FILE:all_features> -v)
doctest_add_test(NAME help              ${common_args} -h)
doctest_add_test(NO_OUTPUT NAME outfile ${common_args} -c   -out=temp) # just to exercise the output option
doctest_add_test(NAME count             ${common_args} -c   -sf=*coverage*)
doctest_add_test(NAME list_test_cases   ${common_args} -ltc -sf=*coverage*)
doctest_add_test(NAME list_test_suites  ${common_args} -lts -sf=*coverage*)
doctest_add_test(NAME list_reporters    ${common_args} -lr  -sf=*coverage*)

# options
doctest_add_test(NAME all_binary  ${common_args} -tc=all?binary* -s) # print all binary asserts - for getAssertString()
doctest_add_test(NAME abort_after ${common_args} -aa=2 -e=off   -sf=*coverage*) # abort after 2 assert fails and parse a negative
doctest_add_test(NAME first_last  ${common_args} -f=2 -l=4      -sf=*coverage*) # run a range
doctest_add_test(NAME filter_1    ${common_args} -ts=none) # should filter out all
# -order-by=name to avoid different output depending on the compiler used. See https://github.com/onqtam/doctest/issues/287
doctest_add_test(NAME filter_2    COMMAND $<TARGET_FILE:all_features>   -tse=* -nv -order-by=name) # should filter out all + print skipped
doctest_add_test(NAME filter_3    ${common_args} -sc=from*,sc* -sce=sc2 -sf=*subcases*) # enter a specific subcase - sc1
doctest_add_test(NAME order_1     ${common_args} -ob=suite -ns          -sf=*test_cases_and_suites*)
doctest_add_test(NAME order_2     ${common_args} -ob=name               -sf=*test_cases_and_suites*)
doctest_add_test(NAME order_3     ${common_args} -ob=rand               -sfe=*) # exclude everything for no output

################################################################################
## VARIATION OF THE BUILD WITH DOCTEST DISABLED - SHOULD STILL COMPILE
################################################################################

if(DEFINED ENV{CODE_COVERAGE})
    return() # do not continue with the disabled example
endif()

add_executable(disabled ${files_all})
target_compile_definitions(disabled PRIVATE DOCTEST_CONFIG_DISABLE)
target_link_libraries(disabled doctest ${CMAKE_THREAD_LIBS_INIT})

doctest_add_test(NAME disabled COMMAND $<TARGET_FILE:disabled>)

# TODO: think about fixing these in a different way! - see issue #61 or commit 6b61e8aa3818c5ea100cedc1bb48a60ea10df6e8
if(MSVC)
    target_compile_options(disabled PRIVATE /wd4505) # unreferenced local function has been removed
    target_compile_options(disabled PRIVATE /wd4100) # unreferenced formal parameter
    target_compile_options(disabled PRIVATE /wd4189) # local variable is initialized but not referenced
endif()

if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    target_compile_options(disabled PRIVATE -Wno-unknown-warning-option)
    target_compile_options(disabled PRIVATE -Wno-unneeded-internal-declaration)
    target_compile_options(disabled PRIVATE -Wno-unused-function)
    target_compile_options(disabled PRIVATE -Wno-unused-parameter)
    target_compile_options(disabled PRIVATE -Wno-unused-variable)
    target_compile_options(disabled PRIVATE -Wno-unused-template)
elseif(CMAKE_CXX_COMPILER_ID MATCHES "GNU")
    target_compile_options(disabled PRIVATE -Wno-unused-function)
    target_compile_options(disabled PRIVATE -Wno-unused-parameter)
    target_compile_options(disabled PRIVATE -Wno-unused-variable)
endif()

=== examples/combining_the_same_tests_built_differently_in_multiple_shared_objects/CMakeLists.txt ===
# for more information about this example refer to the GitHub issue: https://github.com/onqtam/doctest/issues/436

# create the test runner, to which all other targets will link to
add_library(test_runner SHARED test_runner.cpp)
target_link_libraries(test_runner PUBLIC doctest)

add_library(default SHARED default.cpp)
target_link_libraries(default PUBLIC doctest test_runner)
set_target_properties(default PROPERTIES CXX_VISIBILITY_PRESET hidden)

add_library(return42 SHARED return42.cpp)
target_link_libraries(return42 PUBLIC doctest test_runner)
set_target_properties(return42 PROPERTIES CXX_VISIBILITY_PRESET hidden)

add_executable(same_tests_multiple_configurations main.cpp)
target_link_libraries(same_tests_multiple_configurations PUBLIC default return42 doctest test_runner)

# the output on a GitHub Actions Windows build with cl.exe when printing __FILE__ in the fileOrderComparator is the following:
#
# ..\examples\combining_the_same_tests_built_differently_in_multiple_shared_objects\test_runner.cpp
# ..\examples\combining_the_same_tests_built_differently_in_multiple_shared_objects\main.cpp
# ..\examples\combining_the_same_tests_built_differently_in_multiple_shared_objects\main.cpp
# ..\examples\combining_the_same_tests_built_differently_in_multiple_shared_objects\test_runner.cpp
# ..\examples\combining_the_same_tests_built_differently_in_multiple_shared_objects\main.cpp
# d:\a\doctest\doctest\examples\combining_the_same_tests_built_differently_in_multiple_shared_objects\foo.h
# ..\examples\combining_the_same_tests_built_differently_in_multiple_shared_objects\main.cpp
# d:\a\doctest\doctest\examples\combining_the_same_tests_built_differently_in_multiple_shared_objects\foo.h
# ..\examples\combining_the_same_tests_built_differently_in_multiple_shared_objects\main.cpp
# d:\a\doctest\doctest\examples\combining_the_same_tests_built_differently_in_multiple_shared_objects\foo.h
#
# and the output from cl.exe on AppVeyor or on my local Windows setup is the following:
#
# C:\projects\doctest\examples\combining_the_same_tests_built_differently_in_multiple_shared_objects\test_runner.cpp
# C:\projects\doctest\examples\combining_the_same_tests_built_differently_in_multiple_shared_objects\main.cpp
# C:\projects\doctest\examples\combining_the_same_tests_built_differently_in_multiple_shared_objects\main.cpp
# c:\projects\doctest\examples\combining_the_same_tests_built_differently_in_multiple_shared_objects\foo.h
# c:\projects\doctest\examples\combining_the_same_tests_built_differently_in_multiple_shared_objects\foo.h
# C:\projects\doctest\examples\combining_the_same_tests_built_differently_in_multiple_shared_objects\test_runner.cpp
# c:\projects\doctest\examples\combining_the_same_tests_built_differently_in_multiple_shared_objects\foo.h
# C:\projects\doctest\examples\combining_the_same_tests_built_differently_in_multiple_shared_objects\main.cpp
# c:\projects\doctest\examples\combining_the_same_tests_built_differently_in_multiple_shared_objects\foo.h
# c:\projects\doctest\examples\combining_the_same_tests_built_differently_in_multiple_shared_objects\foo.h
# c:\projects\doctest\examples\combining_the_same_tests_built_differently_in_multiple_shared_objects\foo.h
# C:\projects\doctest\examples\combining_the_same_tests_built_differently_in_multiple_shared_objects\test_runner.cpp
# c:\projects\doctest\examples\combining_the_same_tests_built_differently_in_multiple_shared_objects\foo.h
# C:\projects\doctest\examples\combining_the_same_tests_built_differently_in_multiple_shared_objects\main.cpp
# c:\projects\doctest\examples\combining_the_same_tests_built_differently_in_multiple_shared_objects\foo.h
# c:\projects\doctest\examples\combining_the_same_tests_built_differently_in_multiple_shared_objects\foo.h
# c:\projects\doctest\examples\combining_the_same_tests_built_differently_in_multiple_shared_objects\foo.h
# C:\projects\doctest\examples\combining_the_same_tests_built_differently_in_multiple_shared_objects\test_runner.cpp
# c:\projects\doctest\examples\combining_the_same_tests_built_differently_in_multiple_shared_objects\foo.h
# C:\projects\doctest\examples\combining_the_same_tests_built_differently_in_multiple_shared_objects\main.cpp
# c:\projects\doctest\examples\combining_the_same_tests_built_differently_in_multiple_shared_objects\foo.h
# c:\projects\doctest\examples\combining_the_same_tests_built_differently_in_multiple_shared_objects\foo.h
#
# as you can see on GitHub Actions we get a full path for the header and a relative for the sources and
# regardless of case sensitivity (for which there is a difference in fileOrderComparator) we will always
# get a different sorting of the test cases and thus we need NO_OUTPUT on this test so that the CI passes
#
# otherwise the output from test_runner.cpp and main.cpp gets reordered before/after the output frmo the header
# TODO: maybe we should simply remove the output from those 2 .cpp files? then there won't be a problem...
#
doctest_add_test(NO_OUTPUT NAME same_tests_multiple_configurations COMMAND $<TARGET_FILE:same_tests_multiple_configurations> --no-version)

=== examples/mpi/CMakeLists.txt ===
find_package(MPI COMPONENTS CXX)
if(MPI_FOUND)
    add_executable(test_mpi main.cpp mpi.cpp)
    target_link_libraries(test_mpi doctest ${CMAKE_THREAD_LIBS_INIT} MPI::MPI_CXX)

    doctest_add_test(NO_OUTPUT NAME test_mpi COMMAND mpirun -np 3 $<TARGET_FILE:test_mpi>)
endif()

=== debian/changelog ===
doctest (2.4.5+repack0-1) unstable; urgency=medium

  * Update to new upstream version 2.4.5+repack0

 -- Didier Raboud <odyx@debian.org>  Wed, 10 Feb 2021 08:49:19 +0100

=== debian/control ===
Source: doctest
Maintainer: Didier Raboud <odyx@debian.org>
Section: devel
Priority: optional
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 doxygen,
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/debian/doctest
Vcs-Git: https://salsa.debian.org/debian/doctest.git
Homepage: https://github.com/onqtam/doctest

Package: doctest-dev
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Description: Light and feature-rich C++ testing framework
 doctest is a light and feature-rich C++98 / C++11 single-header testing
 framework for unit tests and TDD.
 .
 It is inspired by the unittest {} functionality of the D programming
 language and Python's docstrings - tests can be considered a form of
 documentation and should be able to reside near the production code
 which they test. This isn't possible (or at least practical) with any
 other testing framework for C++.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

# Workaround CMake not using CPPFLAGS.
export DEB_CXXFLAGS_MAINT_APPEND = $(shell dpkg-buildflags --get CPPFLAGS)

override_dh_auto_configure:
	# CMAKE_EXPORT_COMPILE_COMMANDS=ON - "Enable output of compile commands during generation" => verboser build
	# CMAKE_CXX_FLAGS="-fprofile-arcs -ftest-coverage -std=c++11" - Flags in use by upstream
	# CMAKE_INSTALL_LIBDIR=/usr/lib - Forces the cmake configuration in the non-multiarch directory
	# CMAKE_BUILD_TYPE=Debug - We want to see it all
	dh_auto_configure -- -DCMAKE_EXPORT_COMPILE_COMMANDS=ON \
	                     -DCMAKE_CXX_FLAGS="-fprofile-arcs -ftest-coverage -std=c++11 $(shell dpkg-buildflags --get CXXFLAGS)" \
	                     -DCMAKE_INSTALL_LIBDIR=/usr/lib \
	                     -DCMAKE_BUILD_TYPE=Debug

override_dh_auto_test:
	# Clearer output for tests
	dh_auto_test --no-parallel -- ARGS\+=--output-on-failure

override_dh_compress:
	# .md Markdown files shall not be compressed
	dh_compress -X.md

override_dh_install:
	dh_install
	# Verify that the mandatory files are really installed
	[ -r debian/doctest-dev/usr/include/doctest/doctest.h ]
	[ -x debian/doctest-dev/usr/lib/cmake/doctest ]

=== debian/watch ===
version=4
opts=dversionmangle=s/\+repack\d*$//,repacksuffix=+repack,filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/doctest-$1\.tar\.gz/ https://github.com/onqtam/doctest/tags .*/v?(\d\S+)\.tar\.gz

## doctest 2.4.8~ds

=== examples/all_features/CMakeLists.txt ===
--- 
+++ 
@@ -22,6 +22,16 @@
     ${files_with_output}
     concurrency.cpp
     ../../scripts/coverage_maxout.cpp
+    namespace1.cpp
+    namespace2.cpp
+    namespace3.cpp
+    namespace4.cpp
+    namespace5.cpp
+    namespace6.cpp
+    namespace7.cpp
+    namespace8.cpp
+    namespace9.cpp
+    no_failures.cpp
 )
 
 # add the executable
@@ -44,10 +54,20 @@
 
 # add this separately since it shouldn't have output compared to reference output - due to concurrency
 # not adding it for MinGW since it crashes when using mingw-w64-x86_64-8.1.0-release-posix-seh-rt_v6-rev0
-# (also disabled for old XCode builds on travis where there is no thread_local support and this is defined in the build matrix)
+# (also disabled for old XCode builds where there is no thread_local support and this is defined in the build matrix)
 if(NOT MINGW AND NOT DEFINED DOCTEST_THREAD_LOCAL)
     doctest_add_test(NO_OUTPUT NAME concurrency.cpp ${common_args} -sf=*concurrency.cpp -d) # duration: there is no output anyway
 endif()
+
+doctest_add_test(NO_OUTPUT NAME namespace1.cpp ${common_args} -sf=*namespace1.cpp )
+doctest_add_test(NO_OUTPUT NAME namespace2.cpp ${common_args} -sf=*namespace2.cpp )
+doctest_add_test(NO_OUTPUT NAME namespace3.cpp ${common_args} -sf=*namespace3.cpp )
+doctest_add_test(NO_OUTPUT NAME namespace4.cpp ${common_args} -sf=*namespace4.cpp )
+doctest_add_test(NO_OUTPUT NAME namespace5.cpp ${common_args} -sf=*namespace5.cpp )
+doctest_add_test(NO_OUTPUT NAME namespace6.cpp ${common_args} -sf=*namespace6.cpp )
+doctest_add_test(NO_OUTPUT NAME namespace7.cpp ${common_args} -sf=*namespace7.cpp )
+doctest_add_test(NO_OUTPUT NAME namespace8.cpp ${common_args} -sf=*namespace8.cpp )
+doctest_add_test(NO_OUTPUT NAME namespace9.cpp ${common_args} -sf=*namespace9.cpp )
 
 # add this separately since the file has a non-straightforward path
 doctest_add_test(NAME coverage_maxout.cpp ${common_args} -sf=*coverage_maxout.cpp)
@@ -66,12 +86,15 @@
 doctest_add_test(NAME abort_after ${common_args} -aa=2 -e=off   -sf=*coverage*) # abort after 2 assert fails and parse a negative
 doctest_add_test(NAME first_last  ${common_args} -f=2 -l=4      -sf=*coverage*) # run a range
 doctest_add_test(NAME filter_1    ${common_args} -ts=none) # should filter out all
-# -order-by=name to avoid different output depending on the compiler used. See https://github.com/onqtam/doctest/issues/287
-doctest_add_test(NAME filter_2    COMMAND $<TARGET_FILE:all_features>   -tse=* -nv -order-by=name) # should filter out all + print skipped
-doctest_add_test(NAME filter_3    ${common_args} -sc=from*,sc* -sce=sc2 -sf=*subcases*) # enter a specific subcase - sc1
-doctest_add_test(NAME order_1     ${common_args} -ob=suite -ns          -sf=*test_cases_and_suites*)
-doctest_add_test(NAME order_2     ${common_args} -ob=name               -sf=*test_cases_and_suites*)
-doctest_add_test(NAME order_3     ${common_args} -ob=rand               -sfe=*) # exclude everything for no output
+# -order-by=name to avoid different output depending on the compiler used. See https://github.com/doctest/doctest/issues/287
+doctest_add_test(NAME filter_2        COMMAND $<TARGET_FILE:all_features>   -tse=* -nv -order-by=name) # should filter out all + print skipped
+doctest_add_test(NAME filter_3        ${common_args} -sc=from*,sc* -sce=sc2 -sf=*subcases*) # enter a specific subcase - sc1
+doctest_add_test(NAME order_1         ${common_args} -ob=suite -ns          -sf=*test_cases_and_suites*)
+doctest_add_test(NAME order_2         ${common_args} -ob=name               -sf=*test_cases_and_suites*)
+doctest_add_test(NAME order_3         ${common_args} -ob=rand               -sfe=*) # exclude everything for no output
+doctest_add_test(NO_OUTPUT NAME quiet ${common_args} -q -sf=*test_cases_and_suites*) # quiet
+doctest_add_test(NAME minimal         ${common_args} -m -sf=*test_cases_and_suites*) # minimal with summary
+doctest_add_test(NAME minimal_no_fail ${common_args} -m -sf=*no_failures.cpp) # minimal
 
 ################################################################################
 ## VARIATION OF THE BUILD WITH DOCTEST DISABLED - SHOULD STILL COMPILE

=== debian/changelog ===
doctest (2.4.8~ds-1) unstable; urgency=medium

  [ upstream ]
  * new release

  [ Jonas Smedegaard ]
  * update copyright info: update coverage
  * drop patch: applied upstream
  * add patch 2001 to avoid privacy breaches in documentation
  * build html and plaintext documentation from markdown sources;
    build-depend on cmark-gfm (not doxygen)

 -- Jonas Smedegaard <dr@jones.dk>  Fri, 14 Jan 2022 22:32:17 +0100

doctest (2.4.6+repack0-3) unstable; urgency=medium

  * adopt package:
    + add myself as maintainer;
      closes: bug#993493, thanks to Didier 'OdyX' Raboud for past work
  * set Rules-Requires-Root: no
  * drop gitlab CI file, unused by my way of maintaining packages
  * update git-buildpackage config:
    + sign tags;
    + use pristine-tar;
    + filter-out any .git* file;
    + use branch name debian/latest (not debian/master);
    + stop set meta;
    + add usage comment
  * rename and renumber patch as 1001_GCC_11.patch;
    + add file debian/patches/README to source,
      documenting patch naming micro-policy
  * update patch to use DEP-3 header
  * drop git-dpm hint file (no longer used)
  * update watch file:
    + simplify filename mangling; use substitution strings
    + add usage comment
    + set dversionmangle=auto; use repack suffix ~ds
  * update copyright info:
    + fix drop License field MIT: duplicate of Expat
    + list Github issue tracker as preferred upstream contact
    + merge Files sections
      with identical copyright holders and license
    + normalize file and copyright holder lists
    + cover logo files, licensed CC-BY-4.0
    + add references for main licensed files
    + cover my packaging contributions, licensed GPL-3+;
      add related lintian overrides
    + generally add License-Grants
  * use semantic newlines in long description and copyright fields
  * add source helper script copyright-check

 -- Jonas Smedegaard <dr@jones.dk>  Fri, 14 Jan 2022 21:05:18 +0100

doctest (2.4.6+repack0-2) unstable; urgency=medium

  * Orphan package

  * Migrate to unstable
  * S-V: Update to 4.6.0 without changes needed
  * Fix building on GCC-11 thanks to upstream's PR #520

 -- Didier Raboud <odyx@debian.org>  Thu, 02 Sep 2021 08:51:30 +0200

doctest (2.4.6+repack0-1) experimental; urgency=medium

  * Update to new upstream version 2.4.6+repack0
  * Refresh d/copyright and bump S-V to 4.5.1 without changes needed

 -- Didier Raboud <odyx@debian.org>  Tue, 06 Apr 2021 18:50:10 +0200

=== debian/control ===
Source: doctest
Maintainer: Jonas Smedegaard <dr@jones.dk>
Section: devel
Priority: optional
Build-Depends:
 cmake,
 cmark-gfm,
 debhelper-compat (= 13),
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/debian/doctest
Vcs-Git: https://salsa.debian.org/debian/doctest.git
Homepage: https://github.com/onqtam/doctest
Rules-Requires-Root: no

Package: doctest-dev
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Description: Light and feature-rich C++ testing framework
 doctest is a light and feature-rich
 C++98 / C++11 single-header testing framework
 for unit tests and TDD.
 .
 It is inspired by the unittest {} functionality
 of the D programming language and Python's docstrings -
 tests can be considered a form of documentation
 and should be able to reside near the production code
 which they test.
 This isn't possible (or at least practical)
 with any other testing framework for C++.

## doctest 2.4.9~ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -69,6 +69,7 @@
 
 if(${DOCTEST_WITH_MAIN_IN_STATIC_LIB})
     add_library(${PROJECT_NAME}_with_main STATIC EXCLUDE_FROM_ALL ${doctest_parts_folder}/doctest.cpp)
+    add_library(${PROJECT_NAME}::${PROJECT_NAME}_with_main ALIAS ${PROJECT_NAME}_with_main)
     target_compile_definitions(${PROJECT_NAME}_with_main PRIVATE
         DOCTEST_CONFIG_IMPLEMENT_WITH_MAIN)
     set_target_properties(${PROJECT_NAME}_with_main PROPERTIES CXX_STANDARD 11 CXX_STANDARD_REQUIRED ON)
@@ -79,15 +80,11 @@
     include(scripts/cmake/common.cmake)
 
     add_subdirectory(examples/all_features)
-
-    # for code coverage we want exactly one binary to be produced and exercised
-    if(NOT DEFINED ENV{CODE_COVERAGE})
-        add_subdirectory(examples/exe_with_static_libs)
-        add_subdirectory(examples/executable_dll_and_plugin)
-        add_subdirectory(examples/combining_the_same_tests_built_differently_in_multiple_shared_objects)
-        add_subdirectory(scripts/playground)
-        add_subdirectory(examples/mpi)
-    endif()
+    add_subdirectory(examples/exe_with_static_libs)
+    add_subdirectory(examples/executable_dll_and_plugin)
+    add_subdirectory(examples/combining_the_same_tests_built_differently_in_multiple_shared_objects)
+    add_subdirectory(scripts/playground)
+    add_subdirectory(examples/mpi)
 endif()
 
 ################################################################################

=== examples/all_features/CMakeLists.txt ===
--- 
+++ 
@@ -9,6 +9,7 @@
     alternative_macros.cpp
     assertion_macros.cpp
     stringification.cpp
+    double_stringification.cpp
     reporters_and_listeners.cpp
     subcases.cpp
     logging.cpp
@@ -16,12 +17,13 @@
     test_cases_and_suites.cpp
     asserts_used_outside_of_tests.cpp
     enums.cpp
+    decomposition.cpp
 )
 
 set(files_all
     ${files_with_output}
     concurrency.cpp
-    ../../scripts/coverage_maxout.cpp
+    coverage_maxout.cpp
     namespace1.cpp
     namespace2.cpp
     namespace3.cpp
@@ -89,6 +91,7 @@
 # -order-by=name to avoid different output depending on the compiler used. See https://github.com/doctest/doctest/issues/287
 doctest_add_test(NAME filter_2        COMMAND $<TARGET_FILE:all_features>   -tse=* -nv -order-by=name) # should filter out all + print skipped
 doctest_add_test(NAME filter_3        ${common_args} -sc=from*,sc* -sce=sc2 -sf=*subcases*) # enter a specific subcase - sc1
+doctest_add_test(NAME filter_4        ${common_args} -ts=*\\, -tc=*\\: -sc=*\\\\\\,,*:) # escape stuff
 doctest_add_test(NAME order_1         ${common_args} -ob=suite -ns          -sf=*test_cases_and_suites*)
 doctest_add_test(NAME order_2         ${common_args} -ob=name               -sf=*test_cases_and_suites*)
 doctest_add_test(NAME order_3         ${common_args} -ob=rand               -sfe=*) # exclude everything for no output
@@ -96,19 +99,39 @@
 doctest_add_test(NAME minimal         ${common_args} -m -sf=*test_cases_and_suites*) # minimal with summary
 doctest_add_test(NAME minimal_no_fail ${common_args} -m -sf=*no_failures.cpp) # minimal
 
+add_executable(disabled_but_evaluated assert_returns_disabled.cpp assert_returns_disabled_evaluate.cpp)
+target_compile_definitions(disabled_but_evaluated PRIVATE DOCTEST_CONFIG_DISABLE)
+target_link_libraries(disabled_but_evaluated doctest ${CMAKE_THREAD_LIBS_INIT})
+
+doctest_add_test_impl(NO_OUTPUT NAME disabled_but_evaluated COMMAND $<TARGET_FILE:disabled_but_evaluated>)
+
+if(MSVC)
+    target_compile_options(disabled_but_evaluated PRIVATE /wd4702) # unreachable code
+endif()
+
+if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
+    target_compile_options(disabled_but_evaluated PRIVATE -Wno-global-constructors)
+    target_compile_options(disabled_but_evaluated PRIVATE -Wno-unused-variable)
+elseif(CMAKE_CXX_COMPILER_ID MATCHES "GNU")
+    target_compile_options(disabled_but_evaluated PRIVATE -Wno-unused-variable)
+endif()
+
 ################################################################################
-## VARIATION OF THE BUILD WITH DOCTEST DISABLED - SHOULD STILL COMPILE
+## CONFIG TESTS - TESTS WITH VARIOUS CONFIGURATION OPTIONS
 ################################################################################
 
-if(DEFINED ENV{CODE_COVERAGE})
-    return() # do not continue with the disabled example
-endif()
+function(add_test_all_features test_name flags)
+    add_executable(${test_name} ${files_with_output})
+    target_compile_definitions(${test_name} PRIVATE ${flags})
+    target_link_libraries(${test_name} doctest ${CMAKE_THREAD_LIBS_INIT})
 
-add_executable(disabled ${files_all})
-target_compile_definitions(disabled PRIVATE DOCTEST_CONFIG_DISABLE)
-target_link_libraries(disabled doctest ${CMAKE_THREAD_LIBS_INIT})
+    doctest_add_test_impl(NAME ${test_name} COMMAND $<TARGET_FILE:${test_name}> --no-skipped-summary --no-version -ob=name)
+endfunction()
 
-doctest_add_test(NAME disabled COMMAND $<TARGET_FILE:disabled>)
+add_test_all_features(no_multithreading DOCTEST_CONFIG_NO_MULTITHREADING)
+add_test_all_features(no_multi_lane_atomics DOCTEST_CONFIG_NO_MULTI_LANE_ATOMICS)
+add_test_all_features(disabled DOCTEST_CONFIG_DISABLE)
+add_test_all_features(std_headers DOCTEST_CONFIG_USE_STD_HEADERS)
 
 # TODO: think about fixing these in a different way! - see issue #61 or commit 6b61e8aa3818c5ea100cedc1bb48a60ea10df6e8
 if(MSVC)

=== debian/changelog ===
doctest (2.4.9~ds-1) unstable; urgency=medium

  [ upstream ]
  *new release

  [ Jonas Smedegaard ]
  * drop patch cherry-picked upstream now applied
  * update and unfuzz patches
  * declare compliance with Debian Policy 4.6.1

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 17 Sep 2022 14:44:56 +0200

doctest (2.4.8~ds-2) unstable; urgency=medium

  * add patch cherry-picked upstream
    to fix move-only types failing to decompose correctly;
    closes: bug#1005500, thanks to Andreas Tille and Nilesh Patra

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 20 Apr 2022 20:48:38 +0200

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
  cmake,
  cmark-gfm,
  debhelper-compat (= 13),
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Vcs-Browser: https://salsa.debian.org/debian/doctest
 Vcs-Git: https://salsa.debian.org/debian/doctest.git
 Homepage: https://github.com/onqtam/doctest

## doctest 2.4.11

=== CMakeLists.txt ===
--- 
+++ 
@@ -51,6 +51,14 @@
     add_custom_target(assemble_single_header ALL DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/doctest/doctest.h)
 else()
     target_include_directories(${PROJECT_NAME} INTERFACE $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/>)
+endif()
+
+if(CMAKE_BUILD_TYPE STREQUAL "Debug")
+	if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
+		if (NOT WIN32)
+			set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -gdwarf-4 ")
+		endif()
+	endif()
 endif()
 
 # hack to support building on XCode 6 and 7 - propagate the definition to everything
@@ -136,6 +144,11 @@
         FILES "doctest/doctest.h"
         DESTINATION "${include_install_dir}/doctest"
     )
+    install(
+        DIRECTORY "doctest/extensions"
+        DESTINATION "${include_install_dir}/doctest"
+        FILES_MATCHING PATTERN "*.h"
+    )
 
     install(
         FILES "${project_config}" "${version_config}"

=== debian/changelog ===
doctest (2.4.11-1) unstable; urgency=medium

  [ upstream ]
  * new release(s)

  [ Jonas Smedegaard ]
  * declare compliance with Debian Policy 4.6.2
  * update and unfuzz patch
  * update copyright info: update coverage
  * orphan package

 -- Jonas Smedegaard <dr@jones.dk>  Thu, 06 Jul 2023 19:56:11 +0200

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,12 @@
 Source: doctest
-Maintainer: Jonas Smedegaard <dr@jones.dk>
+Maintainer: Debian QA Group <packages@qa.debian.org>
 Section: devel
 Priority: optional
 Build-Depends:
  cmake,
  cmark-gfm,
  debhelper-compat (= 13),
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/debian/doctest
 Vcs-Git: https://salsa.debian.org/debian/doctest.git
 Homepage: https://github.com/onqtam/doctest

## doctest 2.4.12

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.0)
+cmake_minimum_required(VERSION 3.5)
 
 if(POLICY CMP0077)
     cmake_policy(SET CMP0077 NEW)
@@ -95,6 +95,8 @@
     add_subdirectory(examples/mpi)
 endif()
 
+set(DOCTEST_CMAKE_HELPER "${CMAKE_CURRENT_SOURCE_DIR}/scripts/cmake/doctest.cmake" CACHE PATH "Absolute path to to doctest helper file. `include(${DOCTEST_CMAKE_HELPER})`")
+
 ################################################################################
 ## PACKAGE SUPPORT
 ################################################################################

=== examples/all_features/CMakeLists.txt ===
--- 
+++ 
@@ -9,6 +9,7 @@
     alternative_macros.cpp
     assertion_macros.cpp
     stringification.cpp
+    check_doctest_string.cpp
     double_stringification.cpp
     reporters_and_listeners.cpp
     subcases.cpp
@@ -24,6 +25,8 @@
     ${files_with_output}
     concurrency.cpp
     coverage_maxout.cpp
+    bitfields.cpp
+    bitfield_packed_struct.cpp
     namespace1.cpp
     namespace2.cpp
     namespace3.cpp
@@ -61,6 +64,8 @@
     doctest_add_test(NO_OUTPUT NAME concurrency.cpp ${common_args} -sf=*concurrency.cpp -d) # duration: there is no output anyway
 endif()
 
+doctest_add_test(NO_OUTPUT NAME bitfield_packed_struct.cpp ${common_args} -sf=*bitfield_packed_struct.cpp )
+doctest_add_test(NO_OUTPUT NAME bitfields.cpp ${common_args} -sf=*bitfields.cpp )
 doctest_add_test(NO_OUTPUT NAME namespace1.cpp ${common_args} -sf=*namespace1.cpp )
 doctest_add_test(NO_OUTPUT NAME namespace2.cpp ${common_args} -sf=*namespace2.cpp )
 doctest_add_test(NO_OUTPUT NAME namespace3.cpp ${common_args} -sf=*namespace3.cpp )

=== examples/combining_the_same_tests_built_differently_in_multiple_shared_objects/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# for more information about this example refer to the GitHub issue: https://github.com/onqtam/doctest/issues/436
+# for more information about this example refer to the GitHub issue: https://github.com/doctest/doctest/issues/436
 
 # create the test runner, to which all other targets will link to
 add_library(test_runner SHARED test_runner.cpp)
@@ -57,7 +57,7 @@
 # regardless of case sensitivity (for which there is a difference in fileOrderComparator) we will always
 # get a different sorting of the test cases and thus we need NO_OUTPUT on this test so that the CI passes
 #
-# otherwise the output from test_runner.cpp and main.cpp gets reordered before/after the output frmo the header
+# otherwise the output from test_runner.cpp and main.cpp gets reordered before/after the output from the header
 # TODO: maybe we should simply remove the output from those 2 .cpp files? then there won't be a problem...
 #
 doctest_add_test(NO_OUTPUT NAME same_tests_multiple_configurations COMMAND $<TARGET_FILE:same_tests_multiple_configurations> --no-version)

=== examples/executable_dll_and_plugin/CMakeLists.txt ===
add_library(implementation SHARED implementation.cpp implementation_2.cpp)
target_link_libraries(implementation PUBLIC doctest)

add_library(dll SHARED dll.cpp)
target_link_libraries(dll implementation)

add_library(plugin SHARED plugin.cpp)
target_link_libraries(plugin implementation)

add_executable(executable_dll_and_plugin main.cpp)
target_link_libraries(executable_dll_and_plugin dll)
target_link_libraries(executable_dll_and_plugin implementation)

if(NOT WIN32)
    target_link_libraries(executable_dll_and_plugin ${CMAKE_DL_LIBS})
endif()

# have the executable depend on the plugin so it gets built as well when building/starting only the executable
add_dependencies(executable_dll_and_plugin plugin)

# group them together in a single folder inside IDEs
set_target_properties(implementation PROPERTIES FOLDER executable_dll_and_plugin)
set_target_properties(dll PROPERTIES FOLDER executable_dll_and_plugin)
set_target_properties(plugin PROPERTIES FOLDER executable_dll_and_plugin)
set_target_properties(executable_dll_and_plugin PROPERTIES FOLDER executable_dll_and_plugin)

doctest_add_test(NAME executable_dll_and_plugin COMMAND $<TARGET_FILE:executable_dll_and_plugin> --no-version)

=== examples/mpi/CMakeLists.txt ===
find_package(MPI COMPONENTS CXX)
if(MPI_FOUND)
    add_executable(test_mpi main.cpp mpi.cpp)
    target_link_libraries(test_mpi doctest ${CMAKE_THREAD_LIBS_INIT} MPI::MPI_CXX)

    doctest_add_test(NO_OUTPUT NAME test_mpi COMMAND ${MPIEXEC_EXECUTABLE} ${MPIEXEC_NUMPROC_FLAG} 3 $<TARGET_FILE:test_mpi>)
endif()

=== scripts/how_stuff_works/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

project(how_stuff_works)

add_executable(how_exception_translators_work how_exception_translators_work.cpp)
add_executable(how_subcases_work how_subcases_work.cpp)

=== scripts/playground/CMakeLists.txt ===
add_executable(playground main.cpp test.cpp)
target_link_libraries(playground doctest)

doctest_add_test(NAME playground NO_OUTPUT COMMAND $<TARGET_FILE:playground> -nv)

#add_custom_command(TARGET playground POST_BUILD COMMAND $<TARGET_FILE:${PROJECT_NAME}>)
#add_custom_command(TARGET playground POST_BUILD COMMAND ctest -C $<CONFIGURATION> --output-on-failure)

=== debian/changelog ===
doctest (2.4.12-1) unstable; urgency=medium

  * Adopt package (Closes: #1057378)
  * New upstream version 2.4.12
  * Declare compliance with Debian Policy 4.7.2
  * Updated gbp.conf to use git-pbuilder
  * Fixed QA upload changelog warning for 2.4.11-1
  * Updated URLs in upstream metadata, copyright, and control file
  * Updated maintainer to myself in control file
  * Add doc-base registration for html and text
  * Update and unfuzz patches
  * Removed non existing doc/html_generated file exclude path from copyright

 -- Syed Shahrukh Hussain <syed.shahrukh@ossrevival.org>  Wed, 30 Jul 2025 12:56:11 +0500

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,15 @@
 Source: doctest
-Maintainer: Debian QA Group <packages@qa.debian.org>
+Maintainer: Syed Shahrukh Hussain <syed.shahrukh@ossrevival.org>
 Section: devel
 Priority: optional
 Build-Depends:
  cmake,
  cmark-gfm,
  debhelper-compat (= 13),
-Standards-Version: 4.6.2
-Vcs-Browser: https://salsa.debian.org/debian/doctest
-Vcs-Git: https://salsa.debian.org/debian/doctest.git
-Homepage: https://github.com/onqtam/doctest
+Standards-Version: 4.7.2
+Vcs-Browser: https://salsa.debian.org/syed/doctest
+Vcs-Git: https://salsa.debian.org/syed/doctest.git
+Homepage: https://github.com/doctest/doctest
 Rules-Requires-Root: no
 
 Package: doctest-dev

=== debian/rules ===
--- 
+++ 
@@ -1,10 +1,16 @@
 #!/usr/bin/make -f
 
-%:
-	dh $@
+DOCS_SRC = README.md $(wildcard doc/markdown/*.md)
+ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
+DOCS = $(DOCS_SRC:md=html) $(DOCS_SRC:md=txt)
+CHANGELOGS = CHANGELOG.html CHANGELOG.txt
+endif
 
 # Workaround CMake not using CPPFLAGS.
 export DEB_CXXFLAGS_MAINT_APPEND = $(shell dpkg-buildflags --get CPPFLAGS)
+
+override_dh_clean:
+	dh_clean -- $(DOCS) $(CHANGELOGS)
 
 override_dh_auto_configure:
 	# CMAKE_EXPORT_COMPILE_COMMANDS=ON - "Enable output of compile commands during generation" => verboser build
@@ -16,16 +22,29 @@
 	                     -DCMAKE_INSTALL_LIBDIR=/usr/lib \
 	                     -DCMAKE_BUILD_TYPE=Debug
 
+execute_after_dh_auto_build: $(DOCS) $(CHANGELOGS)
+
 override_dh_auto_test:
 	# Clearer output for tests
 	dh_auto_test --no-parallel -- ARGS\+=--output-on-failure
-
-override_dh_compress:
-	# .md Markdown files shall not be compressed
-	dh_compress -X.md
 
 override_dh_install:
 	dh_install
 	# Verify that the mandatory files are really installed
 	[ -r debian/doctest-dev/usr/include/doctest/doctest.h ]
 	[ -x debian/doctest-dev/usr/lib/cmake/doctest ]
+
+override_dh_installdocs:
+	dh_installdocs -- $(DOCS)
+
+override_dh_installchangelogs:
+	dh_installchangelogs -- $(CHANGELOGS)
+
+%.html: %.md
+	cmark-gfm $< > $@
+
+%.txt: %.md
+	cmark-gfm --to plaintext $< > $@
+
+%:
+	dh $@

=== debian/watch ===
version=4
# check: uscan --report
# update: gbp import-orig --upstream-vcs-tag=vX.Y.Z --uscan

opts=\
repacksuffix=~ds,\
filenamemangle=s/.*?(@ANY_VERSION@@ARCHIVE_EXT@)/@PACKAGE@-$1/,\
dversionmangle=auto \
https://github.com/onqtam/doctest/tags \
.*?@ANY_VERSION@@ARCHIVE_EXT@
